package ru.neroduckale.nerodays;

import com.google.gson.JsonObject;
import net.minecraft.network.chat.Component;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.world.entity.LivingEntity;
import net.minecraftforge.event.ServerChatEvent;
import net.minecraftforge.event.TickEvent;
import net.minecraftforge.event.entity.living.LivingDeathEvent;
import net.minecraftforge.event.entity.player.AdvancementEvent;
import net.minecraftforge.eventbus.api.SubscribeEvent;

import java.awt.*;
import java.io.IOException;

import static ru.neroduckale.nerodays.nerodays.*;


public class Events {
    private static int days;

    public String getLocalizedDeathMessage(LivingEntity p_19343_, DamageSource dms) {
        LivingEntity livingentity = p_19343_.getKillCredit();
        String s = "death.attack." + dms.msgId;
        String s1 = s + ".player";
        String nicknameKilled = p_19343_.getDisplayName().getString();

        var a = json.get(s).getAsString();
        LOGGER.error(a);
        if (livingentity != null) {
            if (json.get(s1) != null) {
                a = json.get(s1).getAsString();
            }
            return String.format(a, nicknameKilled, livingentity.getDisplayName().getString());
        }
        return String.format(a, nicknameKilled);
    }


    @SubscribeEvent
    public void NewDay(TickEvent.LevelTickEvent worldTickEvent) throws IOException {
        if (worldTickEvent.level.getDayTime() % 24000 == 0) {
            var a = worldTickEvent.level.getDayTime() / 24000;
            if (days != a) {
                days = (int) a;
            } else {return;}
            var m = "Новый день! День: " + a;
            LOGGER.error(m);
            serverwebhook.setContent(m);
            serverwebhook.execute();
            serverwebhook.setContent("");
        }
    }


    @SubscribeEvent
    public void NewMsg(ServerChatEvent event) throws IOException {
        var nickname = event.getUsername();
        var message = event.getMessage().getString();
        webhook.setUsername(nickname);
        webhook.setContent(message);
        webhook.setAvatarUrl("https://ely.by/services/skins-renderer?url=http://skinsystem.ely.by/skins/%s&scale=10&renderFace=1".formatted(nickname));
        webhook.execute();
    }



    @SubscribeEvent
    public void Death(LivingDeathEvent event) throws IOException {

        if (event.getEntity() instanceof ServerPlayer player) {
            var nickname = player.getDisplayName().getString();
            var prichina = event.getSource();
            var message = nickname + " умер...";
            var chlen = this.getLocalizedDeathMessage(player, prichina);
            DiscordWebhook.EmbedObject embed = new DiscordWebhook.EmbedObject()
                    .setAuthor(message, "", "https://ely.by/services/skins-renderer?url=http://skinsystem.ely.by/skins/%s&scale=10&renderFace=1".formatted(nickname))
                    .setTitle(chlen)
                    .setColor(Color.red);
            serverwebhook.addEmbed(embed);
            serverwebhook.execute();

        }
    }


    @SubscribeEvent
    public void onNewAchivment(AdvancementEvent.AdvancementEarnEvent event) throws IOException {

        var nickname = event.getEntity().getDisplayName().getString();
        var achivka = event.getAdvancement().toString();
        var message = nickname + " получил ачивку!";
        DiscordWebhook.EmbedObject embed = new DiscordWebhook.EmbedObject()
                .setAuthor(message, "", "https://ely.by/services/skins-renderer?url=http://skinsystem.ely.by/skins/%s&scale=10&renderFace=1".formatted(nickname))
                .setTitle(achivka)
                .setColor(Color.red);
        serverwebhook.addEmbed(embed);
        serverwebhook.execute(); //НЕ ПРОВЕРЯЛ
    }

}

